﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.51
@EndOfDesignText@
'Filter class
Sub Class_Globals
	Dim NumberOfDays As Int = 90
End Sub

Public Sub Initialize
	
End Sub

'Return True to allow the request to proceed.
Public Sub Filter(req As ServletRequest, resp As ServletResponse) As Boolean
	Dim auths As List = req.GetHeaders("Authorization")
	Dim success As Boolean = False
	resp.SetHeader("Access-Control-Allow-Origin","*")
	resp.SetHeader("Access-Control-Allow-Methods" ,"GET, POST, OPTIONS")
	resp.SetHeader("Access-Control-Allow-Headers", "Access-Control-Allow-Headers, Origin, Accept, X-Requested-With, Content-Type, Access-Control-Request-Method, Access-Control-Request-Headers, Authorization")
	If auths.Size > 0 Then
		Dim auth As String = auths.Get(0)
		If auth.StartsWith("BANBasic") = True Then
			Dim b64 As String = auth.SubString("BANBasic ".Length)
			Dim su As StringUtils
			Dim b() As Byte = su.DecodeBase64(b64)
			Dim raw As String = BytesToString(b, 0, b.Length, "utf8")
			Dim UsernameAndPassword() As String = Regex.Split(":", raw)
			If CheckUsernameAndPassword(UsernameAndPassword) Then
				resp.Write($"{"BANanoStatus": 801, "BANToken": "${EncryptText(UsernameAndPassword(0) & ":" & UsernameAndPassword(1), "MyTopSecretPassword")}", "BANExpires": ${NumberOfDays}}"$)
				Return False					
			End If
		End If
		If auth.StartsWith("BANBearer") = True Then
			Dim b64 As String = auth.SubString("BANBearer ".Length)
			Dim dec As String = DecryptText(b64, "MyTopSecretPassword")
			Dim UsernameAndPassword() As String = Regex.Split(":", dec)
			success = CheckUsernameAndPassword(UsernameAndPassword)			
		End If		
	End If
	If success = False Then
		' we need to login
		resp.Write($"{"BANanoStatus": 800}"$)			
	End If
	Return success
End Sub

Sub CheckUsernameAndPassword(UsernameAndPassword() As String) As Boolean
	If UsernameAndPassword.Length = 2 Then
		'up to you to decide which credentials are allowed <---------------------------
		If UsernameAndPassword(0) = "UserName" And UsernameAndPassword(1) = "Password" Then
			Return True
		End If
	End If
	Return False
End Sub

Sub EncryptText(text As String, password As String) As String
	Try
		Dim Su As StringUtils
		Dim c As B4XCipher
		Dim Crypt() As Byte = c.Encrypt(text.GetBytes("utf8"), password)
		Return Su.EncodeBase64(Crypt)
	Catch
		Return ""
	End Try
End Sub

Sub DecryptText(text As String, password As String) As String
	Try
		Dim Su As StringUtils
		Dim c As B4XCipher
		Dim BtCrypt() As Byte  = Su.DecodeBase64(text)
		Dim b() As Byte = c.Decrypt(BtCrypt, password)
		Return BytesToString(b, 0, b.Length, "utf8")
	Catch
		Return ""
	End Try
End Sub